#!/usr/bin/env python

import logging
import os, sys
from apscheduler.scheduler import Scheduler
from lib.job_manager import Job_Manager
from lib.plugin_manager import Plugin_Manager
from lib.app_context import App_Context
from lib.plugin_cache_manager import Plugin_Cache_Manager
from lib.plugin_response_handler import Plugin_Response_Handler
from lib.rabbitmq_manager import RabbitMQ_Manager


def main():
    print "Agent started.."
    os.chdir(sys.path[0])
    context = App_Context()
    scheduler = Scheduler(context.scheduler_config)
    job_manager = Job_Manager(scheduler)
    cache_manager = Plugin_Cache_Manager(context)
    rabbitmq_manager = RabbitMQ_Manager(context)
    response_handler = Plugin_Response_Handler(context, rabbitmq_manager)
    Plugin_Manager(job_manager, context, cache_manager, response_handler)

if __name__ == "__main__":
    logging.basicConfig(format="%(asctime)s;%(levelname)s;%(message)s",
                        filename='/var/log/thunderops/agent.log',
                        datefmt='%Y-%m-%d %H:%M:%S',
                        level=logging.DEBUG)
    main()
