import os
import socket
from ConfigParser import SafeConfigParser


class App_Context(object):

    def __init__(self):
        parser = SafeConfigParser()
        settings_file = '/thunderops/agent/etc/settings.conf' 
        parser.read(settings_file)

        self.queue_server = parser.get('Queue', 'Server')
        self.perf_queue = parser.get('Queue', 'PerfQueue')
        self.queue_username = parser.get('Queue', 'UserName')
        self.queue_password = parser.get('Queue', 'Password')
        self.plugin_api = parser.get('App', 'PluginAPI')
        self.tenant = parser.get('App', 'Tenant')
        self.plugins_file = 'plugins.txt'
        self.plugin_cache = parser.get('App', 'PluginCacheFolder')
        self.node_name = socket.gethostname().partition('.')[0].lower()

        self.scheduler_config = {'apscheduler.misfire_grace_time': '10',
              'apscheduler.daemonic': False,
              'apscheduler.coalesce': True,
              'apscheduler.threadpool.max_threads': '50'}
