import logging
import pika


class RabbitMQ_Manager(object):

    def __init__(self, context):
        self._context = context

    def publish_metric(self, metric):
        connection = self.__get_connection()
        try:
            queue_name = self._context.perf_queue
            channel = self.__setup_queue(connection, queue_name)
            self.__publish(channel,
                           '',
                           queue_name,
                           metric)
        except Exception, e:
            logging.exception("error publishing metric: %s", e)

        finally:
            connection.close()

    def __get_connection(self):
        credentials = self.__get_credentials()
        host = self._context.queue_server
        connection_params = pika.ConnectionParameters(host=host,
                                                      credentials=credentials)
        return pika.BlockingConnection(connection_params)

    def __get_credentials(self):
        username = self._context.queue_username
        password = self._context.queue_password
        return pika.PlainCredentials(username, password)

    def __setup_queue(self, connection, queue_name):
        channel = connection.channel()
        channel.queue_declare(queue=queue_name,
                              durable=True)

        return channel

    def __publish(self, channel, exchange, route, message):
        channel.basic_publish(exchange=exchange,
                              routing_key=route,
                              body=message,
                              properties=pika.BasicProperties(delivery_mode=2))
